Problem:
2 seconds
256 megabytes
standard input
standard output
In distant future on Earth day lasts for n hours and that’s why there are n timezones. Local times in adjacent timezones differ by one hour. For describing local time, hours numbers from 1 to nare used, i.e. there is no time “0 hours”, instead of it “n hours” is used. When local time in the 1st timezone is 1 hour, local time in the ith timezone is i hours.
Some online programming contests platform wants to conduct a contest that lasts for an hour in such a way that its beginning coincides with beginning of some hour (in all time zones). The platform knows, that there are a_{i} people from ith timezone who want to participate in the contest. Each person will participate if and only if the contest starts no earlier than s hours 00 minutes local time and ends not later than f hours 00 minutes local time. Values s and f are equal for all time zones. If the contest starts at f hours 00 minutes local time, the person won’t participate in it.
Help platform select such an hour, that the number of people who will participate in the contest is maximum.
The first line contains a single integer n (2 ≤ n ≤ 100 000) — the number of hours in day.
The second line contains n spaceseparated integers a_{1}, a_{2}, …, a_{n} (1 ≤ a_{i} ≤ 10 000), where a_{i}is the number of people in the ith timezone who want to participate in the contest.
The third line contains two spaceseparated integers s and f (1 ≤ s < f ≤ n).
Output a single integer — the time of the beginning of the contest (in the first timezone local time), such that the number of participants will be maximum possible. If there are many answers, output the smallest among them.
input
3 1 2 3 1 3
3
input
5 1 2 3 4 1 1 3
4
In the first example, it’s optimal to start competition at 3 hours (in first timezone). In this case, it will be 1 hour in the second timezone and 2 hours in the third timezone. Only one person from the first timezone won’t participate.
In second example only people from the third and the fourth timezones will participate.
Solution：
Noteworthy:
 Phrasing of the problem is a bit confusing. But basically, what you need to do is to find the continuous fs1 time zones such that the sum of their participants is the largest over all other possibilities.
 Note that groups [n1, n , 1 ,2] is also a possible continuous time zones choice for fs1 = 4. Modular operator would help a lot.
 To avoid repetitive addition of participants from different groups, use a sliding window or a prefix sum. That way, the overall complexity of addition would be O(N).

Long time no practice, rusty hands……